'use strict';

// Handle incoming clicks from bandaids.js & '/installed'
try
{
  if (parseUri.parseSearch(location.search).aadisabled === 'true')
  {
    $('#acceptable_ads_info').show();
  }
}
catch (ex)
{}

// Check or uncheck each loaded DOM option checkbox according to the
// user's saved settings.
var generalInit = function () {
    // initialize language drop-down
    initializeLanguageMenu();

    var subs = BG.get_subscriptions_minus_text();

    //if the user is currently subscribed to AA
    //then 'check' the acceptable ads button.
    if ('acceptable_ads' in subs &&
      subs.acceptable_ads.subscribed)
    {
      $('#acceptable_ads').prop('checked', true);
    }

    for (var name in optionalSettings) {
      if (name === "display_language") {
        if (optionalSettings[name]) {
          $("#display_language > option[value='" + optionalSettings[name] + "']").prop("selected", true);
        }
      } else {
        $('#enable_' + name).
            attr('checked', optionalSettings[name]);
      }
    }

    $("input.feature[type='checkbox']").change(function () {
        var isEnabled = $(this).is(':checked');
        var name = this.id.substring(7); // TODO: hack
        var aaContainingDiv = $("div[name='acceptable_ads']");
        var aaCheckbox = $(aaContainingDiv).find('input');
        if (this.id === 'acceptable_ads') {
          if (isEnabled) {
            $('#acceptable_ads_info').slideUp();
            aaCheckbox.prop('checked', true);
            $('.subscription_info', aaContainingDiv).text(translate('fetchinglabel'));
            BG.subscribe({ id: 'acceptable_ads' });
          } else {
            $('#acceptable_ads_info').slideDown();
            $('#acceptable_ads_content_blocking_message').text('').slideUp();
            aaCheckbox.prop('checked', false);
            $('.subscription_info', aaContainingDiv).text(translate('unsubscribedlabel'));
            BG.unsubscribe({ id: 'acceptable_ads', del: false });
          }

          return;
        }

        BG.setSetting(name, isEnabled);

      });

    $('#enable_show_advanced_options').change(function () {
        // Reload the page to show or hide the advanced options on the
        // options page -- after a moment so we have time to save the option.
        // Also, disable all advanced options, so that non-advanced users will
        // not end up with debug/beta/test options enabled.
        if (!this.checked) {
          $(".advanced input[type='checkbox']:checked").each(function () {
              BG.setSetting(this.id.substr(7), false);
            });
        }

        window.setTimeout(function () {
            window.location.reload();
          }, 50);
      });

    $("#enable_show_language_selector").change(function() {
      // Reload the page to show or hide the language selector on the
      // options page -- after a moment so we have time to save the option.
      // The page will be reloaded in the correct language.
      window.setTimeout(function() {
        window.location.reload();
      }, 50);
    });

    $("#display_language").change(function() {
      // Set the display language setting when it changes, then
      // reload the page to show the page in the correct language.
      var selection = $("#display_language > option:selected").prop("value");
      BG.setSetting("display_language", selection);
      window.setTimeout(function() {
        window.location.reload();
      }, 50);
    });

    chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
        if (request && request.command !== 'settings_updated') {
          return;
        } else if (!request) {
          return;
        }

        // Reload the page without any query string parameters so that the tab doesn't
        // change on the user.
        window.location = window.location.href.split('?')[0];
        sendResponse({});
      });

  };

  function initializeLanguageMenu() {
  var localeNames = {
    "am":"lang_amharic",
    "ar":"lang_arabic", 
    "bn":"lang_bengali",
    "bg":"lang_bulgarian", 
    "ca":"lang_catalan", 
    "ceb":"lang_cebuano",
    "cs":"lang_czech", 
    "da":"lang_danish", 
    "de":"lang_german", 
    "el":"lang_greek", 
    "en":"lang_english", 
    "es":"lang_spanish", 
    "et":"lang_estonian",
    "fa":"lang_persian",
    "fi":"lang_finnish", 
    "fil":"lang_filipino",
    "fr":"lang_french", 
    "gl":"lang_galician",
    "gu":"lang_gujarati",
    "he":"lang_israeli", 
    "hi":"lang_hindi",
    "hr":"lang_croatian", 
    "hu":"lang_hungarian", 
    "id":"lang_indonesian", 
    "it":"lang_italian", 
    "ja":"lang_japanese",
    "kn":"lang_kannada", 
    "ko":"lang_korean",
    "lt":"lang_lithuania",
    "lv":"lang_latvian",
    "nb":"lang_norwegian", 
    "ms":"lang_malay",
    "ml":"lang_malayalam",
    "mr":"lang_marathi",
    "nl":"lang_dutch", 
    "pl":"lang_polish", 
    "pt_BR":"lang_portuguese_brazil", 
    "pt_PT":"lang_portuguese_portugal", 
    "ro":"lang_romanian", 
    "ru":"lang_russian", 
    "sk":"lang_slovak", 
    "sl":"lang_slovenian", 
    "sr":"lang_serbian", 
    "sv":"lang_swedish", 
    "sw":"lang_swahili",
    "ta":"lang_tamil",
    "te":"lang_telugu",
    "th":"lang_thai",
    "tr":"lang_turkish", 
    "uk":"lang_ukranian", 
    "vi":"lang_vietnamese", 
    "zh_CN":"lang_chinese_simplified", 
    "zh_TW":"lang_chinese_traditional"
  };
  var langOptions = getAvailableLocales();

  for (var i = 0; i < langOptions.length; i++) {
    var langName = translate(localeNames[langOptions[i]]);
    if (langName && langName != "") {
      $("#display_language").append($("<option>", {
          value: langOptions[i], 
          text: langName
        }));
    }
  }
}
